  // search back through parent nodes until we find a DIV
  function getParentDiv(node) {
    var  parent = node.parentNode;
    while(parent != null) {
      if (parent.nodeName == "DIV") {
        return parent;
      }
      parent = parent.parentNode;
    }
    return null;
  }
  
  // return the first IMG child node
  function getChildImg(node) {
    var children = node.getElementsByTagName("IMG");
    if (children.length == 0) return null;
    return children[0];
  }

  // return the first child DIV node
  function getChildDiv(node) {
    var children = node.childNodes;
    var child;
    var lastChild = null;
    for (var i = 0; i < children.length; ++i) {
      child = children[i];
      if (child.nodeName == "DIV") {
        lastChild = child;
      }
    }
    
    return lastChild;
  }

  // toggle the expansion attribute for the div following the specified node
  function toggleBlock(node) {
    var parent = getParentDiv(node);
    if (parent == null) {
      alert("malformed document: parent DIV not found");
      return;
    }

    var calls = getChildDiv(parent);
    if (calls == null) {
      alert("malformed document: child DIV not found");
      return;
    }
    
		// see if we are using an icon image as an expander
    var icon = getChildImg(node);
    if (icon != null) {
    	if (icon.src.search(/Minus.gif/i) > 0) {
	      calls.style.display = "none";
    		icon.src = "Plus.gif";
    	}
    	else {
	      calls.style.display = "";
    	  icon.src = "Minus.gif";
    	}
    	return;
    }
    
		// text characters as an expander
    var plusminus = node.innerHTML
    if (plusminus == "-") {
      calls.style.display = "none";
      node.innerHTML = "+";
    }
    else {
      calls.style.display = "";
      node.innerHTML = "-";
    }
    return;
  }
